# Install
```
npm install vhtml-ui -S
```

# Quick Start
## import the whole vhtml-ui
```
import Vue from 'vue'
import 'vhtml-ui/lib/vhtml.css';
import vhtml from 'vhtml-ui';
vhtml.install(Vue);
```
## import part of vhtml-ui
```
import {
  Select,
  Button
  // ...
} from 'vhtml-ui';
Vue.component(Select.name, Select)
Vue.component(Button.name, Button)
```

# Changelog
Detailed changes for each release are documented in the [release notes](http://git.code.oa.com/boss-fe/vhtml/blob/master/CHANGELOG.zh-CN.md).

# Documentation and API
http://qidian.oa.com/vhtml

# How to dev
build-theme:
	npm run build:theme

install:
	npm install

install-cn:
	npm install --registry=http://registry.npm.taobao.org

dev:
	npm run dev

play:
	npm run dev:play

new:
	node build/bin/new.js $(filter-out $@,$(MAKECMDGOALS))

new-lang:
	node build/bin/new-lang.js $(filter-out $@,$(MAKECMDGOALS))

dist: install
	npm run dist

dist-all:
	npm run dist:all

deploy:
	@npm run deploy

pub:
	npm run pub

pub-all:
	npm run pub:all

test:
	npm run test:watch
