/**
 * 代码修改自：https://github.com/facebook/react/blob/master/packages/react-dom/src/events/BeforeInputEventPlugin.js
 * 通过记录输入前后的文字值，来计算IME输入
 */

import {getText} from '../util/dom';

export default class FallbackCompositionState {
    constructor() {
        this.root = null;
        this.startText = null;
    }

    start(dom) {
        this.root = dom;
        this.startText = getText(this.root);
    }

    end() {
        let start;
        let end;
        const startValue = this.startText;
        const startLength = startValue.length;
        const endValue = getText(this.root);
        const endLength = endValue.length;

        for (start = 0; start < startLength; start++) {
            if (startValue[start] !== endValue[start]) {
                break;
            }
        }

        const minEnd = startLength - start;
        for (end = 1; end <= minEnd; end++) {
            if (startValue[startLength - end] !== endValue[endLength - end]) {
                break;
            }
        }

        const sliceTail = end > 1 ? 1 - end : undefined;
        return endValue.slice(start, sliceTail);
    }
}
