/**
 * 代码拷贝自slate.js
 * https://github.com/ianstormtaylor/slate/blob/56a9db53f44a1c229cfa15b021f53455757c6bf7/packages/slate-react/src/utils/get-html-from-native-paste.js
 * Get clipboard HTML data by capturing the HTML inserted by the browser's
 * native paste action. To make this work, `preventDefault()` may not be
 * called on the `onPaste` event. As this method is asynchronous, a callback
 * is needed to return the HTML content. This solution was adapted from
 * http://stackoverflow.com/a/6804718.
 *
 * @param {Element} el element
 * @param {Function} callback 回调函数
 */
function getHtmlFromNativePaste(el, callback) {
    // Create an off-screen clone of the element and give it focus.
    const clone = document.createElement('textarea');
    // clone.setAttribute('class', '');
    // clone.setAttribute('style', 'position: fixed; left: -9999px');
    document.body.appendChild(clone);
    clone.focus();

    // Tick forward so the native paste behaviour occurs in cloned element and we
    // can get what was pasted from the DOM.
    setTimeout(() => {
        const html = clone.textContent || clone.innerText;
        // console.log(clone.innerHTML);
        // clone.parentNode.removeChild(clone);
        callback(html);
        /*
        if (clone.childElementCount > 0) {
            // If the node contains any child nodes, that is the HTML content.
            const html = clone.innerHTML;
            clone.parentNode.removeChild(clone);
            callback(html);
        }
        else {
            // Only plain text, no HTML.
            callback();
        }
        */
    }, 0);
}

/**
 * Export.
 *
 * @type {Function}
 */

export default getHtmlFromNativePaste;
