/**
 * Return whether a native keypress event is assumed to be a command.
 * This is required because Firefox fires `keypress` events for key commands
 * (cut, copy, select-all, etc.) even though no character is inserted.
 * @param {Event} e event object.
 * @return {boolean} is command or not.
 */
export default function isKeyCommand(e) {
    return (e.ctrlKey || e.altKey || e.metaKey)
        // ctrlKey && altKey is equivalent to AltGr, and is not a command.
        && !(e.ctrlKey && e.altKey);
}
