import Vue from 'vue';
import LoadingBar from './loadingbar.vue';

let LoadingbarConstructor = Vue.extend(LoadingBar);

// /**
//  * 在原型对象上定义用于更新实例属性的方法
//  * @param  {Object} options  更新项
//  */
// LoadingbarConstructor.prototype.update = function (options) {
//     Object.keys(options).forEach((prop) => {
//         this[prop] = options[prop];
//     });
// };

/**
 * 定义一个在全局（body上）创建loadingbar实例的方法
 * @return {Instance} Instance   loadingbar实例
 */
const loadingbar = () => {
    // 设置loadingbar的父节点为body
    let parent = document.body;
    let instance = new LoadingbarConstructor();

    // 父容器的postition 不为absolute时才添加类名
    if (parent.style.position !== 'absolute') {
        parent.className += ' v-loadingbar__container';
    }
    instance.vm = instance.$mount();
    parent.appendChild(instance.vm.$el);

    return instance;
};

export default loadingbar;
