/**
 * bind VModel manually
 * @param {string} dataName name of data.
 * @return {Object} mixin
 */
export default function (dataName) {
    dataName = dataName || 'currentValue';
    return {
        data() {
            const d = {};
            d[dataName] = null;
            return d;
        },
        methods: {
            bindVModel(child) {
                // bind `v-mode`
                const modelConfig = child.$options.model;
                const eventName = modelConfig && modelConfig.event || 'input';
                const valueKey = modelConfig && modelConfig.prop || 'value';
                child.$on(eventName, (value) => this[dataName] = value);
                // Get input component's value.
                this[dataName] = child[valueKey];
            }
        }
    };
}
