/**
 * v-popper 组件使用的所有属性的mixin
 * 拆分之后，方便其他扩展popper的组件使用
 */
import pick from 'lodash/pick';
import pull from 'lodash/pull';

const popperProps = {
    clazz: {
        default: ''
    },
    theme: Object,
    placement: {
        type: String,
        default: 'bottom'
    },
    content: {
        type: String,
        default: ''
    },
    offset: {
        type: Number,
        default: 0
    },
    transition: {
        // 'fade-in-linear'
        type: String,
        default: null
    },
    options: Object,
    useArrow: {
        type: Boolean,
        default: false
    },
    inline: {
        type: Boolean,
        default: false
    },
    fixed: {
        type: Boolean,
        default: false
    },
    priority: {
        type: [Array, String],
        default: null
    },
    boundary: {
        default: 'viewport'
    },
    boundaryGap: {
        type: Number,
        default: 10
    },
    disabled: {
        type: Boolean,
        default: false
    },
    syncWidth: {
        type: Boolean,
        default: false
    },
    // 覆盖zIndexMixin中的默认值
    zIndex: {
        type: [Number, String],
        default: 300
    }
};

export default {
    props: popperProps,

    computed: {
        passdownPopperProps() {
            return pick(this.$props, pull(Object.keys(popperProps), 'options'));
        }
    }
};
