import getScrollbarWidth from 'vhtml-ui/src/utils/scrollbar-width';
import {getComputedStyle} from 'vhtml-ui/src/utils/dom';

const COUNT_KEY = 'data-v-scrollbar-mixin-count';
const OVERFLOW_KEY = 'data-v-scrollbar-mixin-overflow';
const BORDER_RIGHT_KEY = 'data-v-scrollbar-mixin-borderRight';

export default {
    methods: {
        stopScroll() {
            if (!this.isMounted4ScrollbarMixin || this.isStoppedScroll4ScrollbarMixin) {
                return;
            }

            // update html element
            const doc = this.$el.ownerDocument;
            const de = doc.documentElement;
            const bd = doc.body;
            const count = parseInt(de.getAttribute(COUNT_KEY), 10) || 0;
            de.setAttribute(COUNT_KEY, count + 1);
            this.isStoppedScroll4ScrollbarMixin = true;
            if (count >= 1) {
                return;
            }

            bd.setAttribute(OVERFLOW_KEY, bd.style.overflow);
            de.setAttribute(OVERFLOW_KEY, de.style.overflow);
            de.setAttribute(BORDER_RIGHT_KEY, de.style.borderRight);
            const borderRightWidth = parseInt(getComputedStyle(de).borderRightWidth, 10) || 0;
            bd.style.overflow = de.style.overflow = 'hidden';
            de.style.borderRight = `${borderRightWidth + getScrollbarWidth()}px solid transparent`;
        },

        restoreScroll() {
            if (!this.isStoppedScroll4ScrollbarMixin) {
                return;
            }

            const doc = this.$el.ownerDocument;
            const de = doc.documentElement;
            const bd = doc.body;
            const count = parseInt(de.getAttribute(COUNT_KEY), 10) || 0;
            de.setAttribute(COUNT_KEY, count - 1);
            this.isStoppedScroll4ScrollbarMixin = false;
            if (count > 1) {
                return;
            }

            bd.style.overflow = bd.getAttribute(OVERFLOW_KEY);
            de.style.overflow = de.getAttribute(OVERFLOW_KEY);
            de.style.borderRight = de.getAttribute(BORDER_RIGHT_KEY);
        }
    },

    mounted() {
        this.isMounted4ScrollbarMixin = true;
    },

    destroyed() {
        this.restoreScroll();
    }
};
