export default {
    provide() {
        return {
            zIndexBase: this.calcZIndex
        };
    },
    inject: {
        zIndexBase: {
            default: 0
        }
    },
    props: {
        zIndex: {
            type: [Number, String],
            default: 0
        }
    },
    computed: {
        calcZIndex() {
            const zIndex = typeof this.zIndex === 'string'
                ? parseInt(this.zIndex, 10)
                : this.zIndex;
            if (!this.zIndexBase) {
                return zIndex;
            }

            return this.zIndexBase + zIndex / 100;
        },
        calcStyle() {
            return {
                zIndex: this.calcZIndex
            };
        }
    }
};
