import Vue from 'vue';
import * as domUtil from './dom';

/**
 * 获取当前页面的scrollbar宽度，如果没有显示scrollbar就是0
 * reference https://github.com/ElemeFE/element/blob/dev/src/utils/scrollbar-width.js
 * reference https://github.com/noeldelgado/gemini-scrollbar/blob/master/index.js
 * @return {number} scrollbar宽度
 */
export default function () {
    let pageHeight = domUtil.getPageHeight(window) || 0;
    let viewHeight = domUtil.getViewHeight(window) || 0;
    if (Vue.prototype.$isServer || pageHeight <= viewHeight) {
        return 0;
    }

    let noScroll;
    let scroll;
    let oDiv = document.createElement('DIV');

    oDiv.style.cssText = 'position:absolute; visibility:hidden; width:30px;';
    noScroll = document.body.appendChild(oDiv).clientWidth;
    oDiv.style.overflowY = 'scroll';
    scroll = oDiv.clientWidth;
    document.body.removeChild(oDiv);

    return noScroll - scroll;
}
